-- Script para animar esteiras
-- Modificado para Espalhador Hercules 24000C
--
-- Autor: Giants Software
-- Edit: Vinicius LS
-- FBT Modding

source("dataS/scripts/vehicles/specializations/SetTurnedOnEvent.lua");
EsteirasAnimation = {};

function EsteirasAnimation.prerequisitesPresent(specializations)
    return SpecializationUtil.hasSpecialization(Motorized, specializations);
end;

function EsteirasAnimation:load(xmlFile)
		self.combineThreshingScrollers = {};
		Combine.loadScrollers(self, xmlFile, "vehicle.combineThreshingScrollers.combineThreshingScroller", self.combineThreshingScrollers, false);
end;

function EsteirasAnimation:readStream(streamId, connection)
end;

function EsteirasAnimation:writeStream(streamId, connection)
end;

function EsteirasAnimation:delete()
end;

function EsteirasAnimation:mouseEvent(posX, posY, isDown, isUp, button)
end;

function EsteirasAnimation:keyEvent(unicode, sym, modifier, isDown)
end;
 
function EsteirasAnimation:update(dt)
 if self.isClient then
	if self:getIsActive() then
		 if self.isTurnedOn then
                 for _, scroller in pairs(self.combineThreshingScrollers) do
                 scroller.scrollPosition = (scroller.scrollPosition + dt*scroller.scrollSpeed) % scroller.scrollLength;
                 if scroller.shaderParameterComponent == 1 then
                          setShaderParameter(scroller.node, scroller.shaderParameterName, scroller.scrollPosition,0,0,0, false);
                     else
                          setShaderParameter(scroller.node, scroller.shaderParameterName, 0,scroller.scrollPosition,0,0, false);
                     end;
				end;
            end;
		end;
	end;
end;

function EsteirasAnimation:onLeave()
end;

function EsteirasAnimation:draw()
end;

function EsteirasAnimation:startgetIsActive()
			if not self.isThreshing then
                  for _, v in pairs(self.combineThreshingScrollers) do
                      if v.toggleVisibility then
                         setVisibility(v.node, true);
                     end;
                end;
			end;
		end;
		
function EsteirasAnimation:stopgetIsActive()
      if self.isThreshing then
              for _, v in pairs(self.combineThreshingScrollers) do
                 if v.toggleVisibility then
                      setVisibility(v.node, false);
                  end;
        end
    end;
end;
