--Hercules24000C
--Specializacao para o mod Hercules24000C
--Autor: Vinicius LS e Alemao
--Grupo: FBT Modding
--

Hercules24000C = {};

function Hercules24000C.prerequisitesPresent(specializations)
    return true;
end;
function Hercules24000C:load(xmlFile)
    self.rotors = {};
    local i = 0;
    while true do
        local key = string.format("vehicle.rotors.rotor(%d)", i);
        if not hasXMLProperty(xmlFile, key) then
             break;
        end;
        local node = Utils.indexToObject(self.components, getXMLString(xmlFile, key.."#index"));
        local speed = Utils.getNoNil(getXMLFloat(xmlFile, key.."#speed"),0.003);
        if node ~= nil then
            table.insert(self.rotors, {node=node,speed=speed});
        end;
        i = i + 1;
    end;
		self.steeringColumn = {};
		self.steeringColumn.anim = getXMLString(xmlFile, "vehicle.steeringColumn#animName");
		self.steeringColumn.speed = getXMLFloat(xmlFile, "vehicle.steeringColumn#speed");
		self.driveHandle = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.driveHandle#index"));
		
	self.ativarlimpador1 = false;
	self.lpd1 = 650;
	self.ativarlimpador2 = false;
	self.lpd2 = 650;
   
	local rotationPartNodelimpador1 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.limpador1#index"));
    if rotationPartNodelimpador1 ~= nil then
        self.limpador1 = {};
        self.limpador1.node = rotationPartNodelimpador1;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.limpador1#minRot"));
        self.limpador1.minRot = {};
        self.limpador1.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.limpador1.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.limpador1.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.limpador1#maxRot"));
        self.limpador1.maxRot = {};
        self.limpador1.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.limpador1.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.limpador1.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.limpador1.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.limpador1#rotTime"), 2)*1000;
        self.limpador1.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.limpador1#touchRotLimit"), 10));
    end;
	local rotationPartNodelimpador2 = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.limpador2#index"));
    if rotationPartNodelimpador2 ~= nil then
        self.limpador2 = {};
        self.limpador2.node = rotationPartNodelimpador2;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.limpador2#minRot"));
        self.limpador2.minRot = {};
        self.limpador2.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.limpador2.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.limpador2.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.limpador2#maxRot"));
        self.limpador2.maxRot = {};
        self.limpador2.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.limpador2.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.limpador2.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.limpador2.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.limpador2#rotTime"), 2)*1000;
        self.limpador2.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.limpador2#touchRotLimit"), 10));
    end;
    
	local rotacaoprecaofreio = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.precao_freio#index"));
    if rotacaoprecaofreio ~= nil then
        self.precaofreio = {};
        self.precaofreio.node = rotacaoprecaofreio;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.precao_freio#minRot"));
        self.precaofreio.minRot = {};
        self.precaofreio.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.precaofreio.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.precaofreio.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.precao_freio#maxRot"));
        self.precaofreio.maxRot = {};
        self.precaofreio.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.precaofreio.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.precaofreio.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.precaofreio.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.precao_freio#rotTime"), 2)*1000;
        self.precaofreio.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.precao_freio#touchRotLimit"), 10));
    end;
    
	local rotacaocontagiro = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.contagiro#index"));
		if rotacaocontagiro ~= nil then
        self.contagiro = {};
        self.contagiro.node = rotacaocontagiro;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.contagiro#minRot"));
        self.contagiro.minRot = {};
        self.contagiro.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.contagiro.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.contagiro.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.contagiro#maxRot"));
        self.contagiro.maxRot = {};
        self.contagiro.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.contagiro.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.contagiro.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.contagiro.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.contagiro#rotTime"), 2)*1000;
        self.contagiro.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.contagiro#touchRotLimit"), 10));
    end;
    
	local rotacaomarcadordecombustivel = Utils.indexToObject(self.components, getXMLString(xmlFile, "vehicle.combustivel#index"));
    if rotacaomarcadordecombustivel ~= nil then
        self.marcadordecombustivel = {};
        self.marcadordecombustivel.node = rotacaomarcadordecombustivel;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.combustivel#minRot"));
        self.marcadordecombustivel.minRot = {};
        self.marcadordecombustivel.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.marcadordecombustivel.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.marcadordecombustivel.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.combustivel#maxRot"));
        self.marcadordecombustivel.maxRot = {};
        self.marcadordecombustivel.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.marcadordecombustivel.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.marcadordecombustivel.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.marcadordecombustivel.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.combustivel#rotTime"), 2)*1000;
        self.marcadordecombustivel.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.combustivel#touchRotLimit"), 10));
    end;
    
    local velocimetro = Utils.indexToObject(self.rootNode, getXMLString(xmlFile, "vehicle.velocimetro#index"));
    if velocimetro ~= nil then
        self.velocimetro = {};
        self.velocimetro.node = velocimetro;

        local x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.velocimetro#minRot"));
        self.velocimetro.minRot = {};
        self.velocimetro.minRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.velocimetro.minRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.velocimetro.minRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        x, y, z = Utils.getVectorFromString(getXMLString(xmlFile, "vehicle.velocimetro#maxRot"));
        self.velocimetro.maxRot = {};
        self.velocimetro.maxRot[1] = Utils.degToRad(Utils.getNoNil(x, 0));
        self.velocimetro.maxRot[2] = Utils.degToRad(Utils.getNoNil(y, 0));
        self.velocimetro.maxRot[3] = Utils.degToRad(Utils.getNoNil(z, 0));

        self.velocimetro.rotTime = Utils.getNoNil(getXMLString(xmlFile, "vehicle.velocimetro#rotTime"), 2)*1000;
        self.velocimetro.touchRotLimit = Utils.degToRad(Utils.getNoNil(getXMLString(xmlFile, "vehicle.velocimetro#touchRotLimit"), 10));
    end;
end;

function Hercules24000C:delete()
end;

function Hercules24000C:mouseEvent(posX, posY, isDown, isUp, button)
end;

function Hercules24000C:keyEvent(unicode, sym, modifier, isDown)
	if isDown and sym == Input.KEY_l then
		self.ativarlimpador1 = not self.ativarlimpador1;
	end;
	if isDown and sym == Input.KEY_l then
		self.ativarlimpador2 = not self.ativarlimpador2;
	end;
    
	if isDown and sym == Input.KEY_space   then
			self.rotationMaxprecao_freio = not self.rotationMaxprecao_freio;
		end;
end;

function Hercules24000C:update(dt)
		if self.ativarlimpador1 then
		self.lpd1 = self.lpd1 - dt;
		if self.lpd1 < 0 then
			self.rotacaomaximaesquerda = not self.rotacaomaximaesquerda;
			self.rotacaomaximalimpador1 = not self.rotacaomaximalimpador1;
			self.lpd1 = 650;
		end;
	end;
	if self.ativarlimpador2 then
		self.lpd2 = self.lpd2 - dt;
		if self.lpd2 < 0 then
			self.rotacaomaximaesquerda = not self.rotacaomaximaesquerda;
			self.rotacaomaximalimpador2 = not self.rotacaomaximalimpador2;
			self.lpd2 = 650;
		end;
	end;
	
	if self.limpador1 ~= nil then
		local x, y, z = getRotation(self.limpador1.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.limpador1.maxRot, self.limpador1.minRot, 3, self.limpador1.rotTime, dt, not self.rotacaomaximalimpador1);
		setRotation(self.limpador1.node, unpack(newRot));
	end;
	if self.limpador2 ~= nil then
		local x, y, z = getRotation(self.limpador2.node);
		local rot = {x,y,z};
		local newRot = Utils.getMovedLimitedValues(rot, self.limpador2.maxRot, self.limpador2.minRot, 3, self.limpador2.rotTime, dt, not self.rotacaomaximalimpador2);
		setRotation(self.limpador2.node, unpack(newRot));
	end;
    
	if self.precaofreio ~= nil then
			local x, y, z = getRotation(self.precaofreio.node);
			local rot = {x,y,z};
			local newRot = Utils.getMovedLimitedValues(rot, self.precaofreio.maxRot, self.precaofreio.minRot, 3, self.precaofreio.rotTime, dt, not self.rotationMaxprecao_freio);
			setRotation(self.precaofreio.node, unpack(newRot));
		end;
    
	local maxrpmneedle = 900;
			if self.contagiro ~= nil then
				local x, y, z = getRotation(self.contagiro.node);
				y = ((self.contagiro.maxRot[2] - self.contagiro.minRot[2]) / maxrpmneedle) * (self.motor.lastMotorRpm/2.2) + self.contagiro.minRot[2];
				setRotation(self.contagiro.node, x, y ,z);
			end;
    
	local maxfuelguage = 280;
			if self.marcadordecombustivel ~= nil then
				local x, y, z = getRotation(self.marcadordecombustivel.node);
				y = ((self.marcadordecombustivel.maxRot[2] - self.marcadordecombustivel.minRot[2]) / maxfuelguage) * self.fuelFillLevel + self.marcadordecombustivel.minRot[2];
				setRotation(self.marcadordecombustivel.node, x, y ,z);
			end;

    local maxKmh = 70;
	if self.velocimetro ~= nil then
		local x, y, z = getRotation(self.velocimetro.node);
		y = ((self.velocimetro.maxRot[2] - self.velocimetro.minRot[2]) / maxKmh) * self.lastSpeed*3600 + self.velocimetro.minRot[2];
		setRotation(self.velocimetro.node, x, y ,z);
	end;
end;

function Hercules24000C:updateTick(dt)
    if self.isMotorStarted then
        for _,v in pairs(self.rotors) do
            if v.node ~= nil then
                rotate(v.node,v.speed*dt,0,0)
            end;
        end;
	end;
end;

function Hercules24000C:onLeave()
	self:playAnimation(self.steeringColumn.anim, -self.steeringColumn.speed, Utils.clamp(self:getAnimationTime(self.steeringColumn.anim), 0, 1), true);
end;

function Hercules24000C:onEnter()
	self:playAnimation(self.steeringColumn.anim, self.steeringColumn.speed, Utils.clamp(self:getAnimationTime(self.steeringColumn.anim), 0, 1), true);
end;

function Hercules24000C:validateAttacherJoint(implement, jointDesc, dt)
    return true;
end;

function Hercules24000C:draw()
	if self.bcActive then	
			g_currentMission:addExtraPrintText("Key L Ativar/Desativar Limpadores do parabrisa");
		else
			g_currentMission:addExtraPrintText("Key L Ativar/Desativar Limpadores do parabrisa");
	end;
end;
